2016-05-25 17:57:04 +00:00
## FUNC_BUILD=2016052502
2016-02-16 21:15:44 +00:00
## BEGIN Generic functions for osync & obackup written in 2013-2016 by Orsiris de Jong - http://www.netpower.fr - ozy@netpower.fr
2015-11-12 00:37:43 +00:00
## type -p does not work on platforms other than linux (bash). If if does not work, always assume output is not a zero exitcode
if ! type " $BASH " > /dev/null; then
echo "Please run this script only with bash shell. Tested on bash >= 3.2"
exit 127
fi
2016-03-19 09:48:46 +00:00
#### obackup & osync specific code BEGIN ####
## Log a state message every $KEEP_LOGGING seconds. Should not be equal to soft or hard execution time so your log will not be unnecessary big.
KEEP_LOGGING = 1801
## Correct output of sort command (language agnostic sorting)
export LC_ALL = C
# Standard alert mail body
MAIL_ALERT_MSG = " Execution of $PROGRAM instance $INSTANCE_ID on $( date) has warnings/errors. "
#### obackup & osync specific code END ####
#### MINIMAL-FUNCTION-SET BEGIN ####
2015-11-12 00:37:43 +00:00
# Environment variables
_DRYRUN = 0
_SILENT = 0
# Initial error status, logging 'WARN', 'ERROR' or 'CRITICAL' will enable alerts flags
ERROR_ALERT = 0
WARN_ALERT = 0
## allow function call checks #__WITH_PARANOIA_DEBUG
if [ " $_PARANOIA_DEBUG " = = "yes" ] ; then #__WITH_PARANOIA_DEBUG
_DEBUG = yes #__WITH_PARANOIA_DEBUG
fi #__WITH_PARANOIA_DEBUG
## allow debugging from command line with _DEBUG=yes
if [ ! " $_DEBUG " = = "yes" ] ; then
_DEBUG = no
SLEEP_TIME = .1
_VERBOSE = 0
else
SLEEP_TIME = 1
trap 'TrapError ${LINENO} $?' ERR
_VERBOSE = 1
fi
SCRIPT_PID = $$
LOCAL_USER = $( whoami)
LOCAL_HOST = $( hostname)
## Default log file until config file is loaded
if [ -w /var/log ] ; then
LOG_FILE = " /var/log/ $PROGRAM .log "
2016-04-06 18:13:19 +00:00
elif ( [ " $HOME " != "" ] && [ -w " $HOME " ] ) ; then
LOG_FILE = " $HOME / $PROGRAM .log "
2015-11-12 00:37:43 +00:00
else
LOG_FILE = " ./ $PROGRAM .log "
fi
## Default directory where to store temporary run files
if [ -w /tmp ] ; then
RUN_DIR = /tmp
elif [ -w /var/tmp ] ; then
RUN_DIR = /var/tmp
else
RUN_DIR = .
fi
# Default alert attachment filename
ALERT_LOG_FILE = " $RUN_DIR / $PROGRAM .last.log "
# Set error exit code if a piped command fails
set -o pipefail
set -o errtrace
function Dummy {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
sleep .1
}
function _Logger {
2016-03-29 20:55:57 +00:00
local svalue = " ${ 1 } " # What to log to stdout
2015-11-12 00:37:43 +00:00
local lvalue = " ${ 2 :- $svalue } " # What to log to logfile, defaults to screen value
2016-03-29 20:55:57 +00:00
local evalue = " ${ 3 } " # What to log to stderr
2015-11-12 00:37:43 +00:00
echo -e " $lvalue " >> " $LOG_FILE "
2016-03-29 20:55:57 +00:00
# <OSYNC SPECIFIC> Special case in daemon mode where systemctl doesn't need double timestamps
if [ " $sync_on_changes " = = "1" ] ; then
cat <<< " $evalue " 1>& 2 # Log to stderr in daemon mode
2016-04-14 16:01:56 +00:00
elif [ " $_SILENT " -eq 0 ] ; then
2015-11-12 00:37:43 +00:00
echo -e " $svalue "
fi
}
function Logger {
local value = " ${ 1 } " # Sentence to log (in double quotes)
local level = " ${ 2 } " # Log level: PARANOIA_DEBUG, DEBUG, NOTICE, WARN, ERROR, CRITIAL
# <OSYNC SPECIFIC> Special case in daemon mode we should timestamp instead of counting seconds
if [ " $sync_on_changes " = = "1" ] ; then
prefix = " $( date) - "
else
prefix = " TIME: $SECONDS - "
fi
# </OSYNC SPECIFIC>
if [ " $level " = = "CRITICAL" ] ; then
2016-03-29 20:55:57 +00:00
_Logger " $prefix \e[41m $value \e[0m " " $prefix $level : $value " " $level : $value "
2015-11-12 00:37:43 +00:00
ERROR_ALERT = 1
return
elif [ " $level " = = "ERROR" ] ; then
2016-03-29 20:55:57 +00:00
_Logger " $prefix \e[91m $value \e[0m " " $prefix $level : $value " " $level : $value "
2015-11-12 00:37:43 +00:00
ERROR_ALERT = 1
return
elif [ " $level " = = "WARN" ] ; then
2016-03-29 20:55:57 +00:00
_Logger " $prefix \e[93m $value \e[0m " " $prefix $level : $value " " $level : $value "
2015-11-12 00:37:43 +00:00
WARN_ALERT = 1
return
elif [ " $level " = = "NOTICE" ] ; then
_Logger " $prefix $value "
return
elif [ " $level " = = "DEBUG" ] ; then
if [ " $_DEBUG " = = "yes" ] ; then
_Logger " $prefix $value "
return
fi
elif [ " $level " = = "PARANOIA_DEBUG" ] ; then #__WITH_PARANOIA_DEBUG
if [ " $_PARANOIA_DEBUG " = = "yes" ] ; then #__WITH_PARANOIA_DEBUG
_Logger " $prefix $value " #__WITH_PARANOIA_DEBUG
return #__WITH_PARANOIA_DEBUG
fi #__WITH_PARANOIA_DEBUG
else
_Logger "\e[41mLogger function called without proper loglevel.\e[0m"
_Logger " $prefix $value "
fi
}
# Portable child (and grandchild) kill function tester under Linux, BSD and MacOS X
function KillChilds {
local pid = " ${ 1 } "
local self = " ${ 2 :- false } "
if children = " $( pgrep -P " $pid " ) " ; then
for child in $children ; do
2016-04-12 08:16:21 +00:00
Logger " Launching KillChilds \" $child \" true " "DEBUG" #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
KillChilds " $child " true
done
fi
2016-03-31 20:32:03 +00:00
# Try to kill nicely, if not, wait 15 seconds to let Trap actions happen before killing
2016-04-12 08:16:21 +00:00
if ( [ " $self " = = true ] && eval $PROCESS_TEST_CMD > /dev/null 2>& 1) ; then
Logger " Sending SIGTERM to process [ $pid ]. " "DEBUG"
2016-04-10 19:14:07 +00:00
kill -s SIGTERM " $pid "
if [ $? != 0 ] ; then
2016-04-12 08:16:21 +00:00
sleep 15
Logger " Sending SIGTERM to process [ $pid ] failed. " "DEBUG"
kill -9 " $pid "
if [ $? != 0 ] ; then
Logger " Sending SIGKILL to process [ $pid ] failed. " "DEBUG"
return 1
fi
2016-03-31 20:32:03 +00:00
fi
2016-04-12 08:16:21 +00:00
return 0
else
return 0
2015-11-12 00:37:43 +00:00
fi
}
2016-05-25 17:57:04 +00:00
# osync/obackup/pmocr script specific mail alert function, use SendEmail function for generic mail sending
2015-11-12 00:37:43 +00:00
function SendAlert {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2016-02-18 22:28:57 +00:00
local mail_no_attachment =
2016-02-18 19:54:07 +00:00
local attachment_command =
2016-03-22 11:43:01 +00:00
local subject =
2015-11-12 00:37:43 +00:00
2016-05-25 17:57:04 +00:00
# Windows specific settings
local encryption_string =
local auth_string =
2016-03-08 22:54:25 +00:00
if [ " $DESTINATION_MAILS " = = "" ] ; then
return 0
fi
2015-11-12 00:37:43 +00:00
if [ " $_DEBUG " = = "yes" ] ; then
2016-05-25 17:57:04 +00:00
Logger "Debug mode, no warning mail will be sent." "NOTICE"
2015-11-12 00:37:43 +00:00
return 0
fi
# <OSYNC SPECIFIC>
if [ " $_QUICK_SYNC " = = "2" ] ; then
Logger "Current task is a quicksync task. Will not send any alert." "NOTICE"
return 0
fi
# </OSYNC SPECIFIC>
eval " cat \" $LOG_FILE \" $COMPRESSION_PROGRAM > $ALERT_LOG_FILE "
2016-02-16 21:15:44 +00:00
if [ $? != 0 ] ; then
Logger " Cannot create [ $ALERT_LOG_FILE ] " "WARN"
mail_no_attachment = 1
else
mail_no_attachment = 0
fi
2015-11-19 21:39:31 +00:00
MAIL_ALERT_MSG = " $MAIL_ALERT_MSG " $'\n\n' $( tail -n 50 " $LOG_FILE " )
2015-11-12 00:37:43 +00:00
if [ $ERROR_ALERT -eq 1 ] ; then
subject = " Error alert for $INSTANCE_ID "
elif [ $WARN_ALERT -eq 1 ] ; then
subject = " Warning alert for $INSTANCE_ID "
else
subject = " Alert for $INSTANCE_ID "
fi
2016-02-18 19:54:07 +00:00
if [ " $mail_no_attachment " -eq 0 ] ; then
2016-02-16 21:15:44 +00:00
attachment_command = " -a $ALERT_LOG_FILE "
fi
2015-11-12 00:37:43 +00:00
if type mutt > /dev/null 2>& 1 ; then
2016-03-31 10:01:10 +00:00
echo " $MAIL_ALERT_MSG " | $( type -p mutt) -x -s " $subject " $DESTINATION_MAILS $attachment_command
2015-11-12 00:37:43 +00:00
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send alert mail via $( type -p mutt) !!! " "WARN"
2015-11-12 00:37:43 +00:00
else
Logger "Sent alert mail using mutt." "NOTICE"
return 0
fi
fi
if type mail > /dev/null 2>& 1 ; then
2016-02-18 19:54:07 +00:00
if [ " $mail_no_attachment " -eq 0 ] && $( type -p mail) -V | grep "GNU" > /dev/null; then
2015-12-15 12:03:05 +00:00
attachment_command = " -A $ALERT_LOG_FILE "
2016-02-18 19:54:07 +00:00
elif [ " $mail_no_attachment " -eq 0 ] && $( type -p mail) -V > /dev/null; then
2016-03-31 10:01:10 +00:00
attachment_command = " -a $ALERT_LOG_FILE "
2015-12-15 12:03:05 +00:00
else
attachment_command = ""
2015-12-15 12:45:11 +00:00
fi
2016-03-31 10:01:10 +00:00
echo " $MAIL_ALERT_MSG " | $( type -p mail) $attachment_command -s " $subject " $DESTINATION_MAILS
2015-11-12 00:37:43 +00:00
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send alert mail via $( type -p mail) with attachments !!! " "WARN"
2016-03-31 10:01:10 +00:00
echo " $MAIL_ALERT_MSG " | $( type -p mail) -s " $subject " $DESTINATION_MAILS
2015-11-12 00:37:43 +00:00
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send alert mail via $( type -p mail) without attachments !!! " "WARN"
2015-11-12 00:37:43 +00:00
else
Logger "Sent alert mail using mail command without attachment." "NOTICE"
return 0
fi
else
Logger "Sent alert mail using mail command." "NOTICE"
return 0
fi
fi
if type sendmail > /dev/null 2>& 1 ; then
2016-03-31 10:01:10 +00:00
echo -e " Subject: $subject \r\n $MAIL_ALERT_MSG " | $( type -p sendmail) $DESTINATION_MAILS
2015-11-12 00:37:43 +00:00
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send alert mail via $( type -p sendmail) !!! " "WARN"
2015-11-12 00:37:43 +00:00
else
Logger "Sent alert mail using sendmail command without attachment." "NOTICE"
return 0
fi
fi
2016-05-25 17:57:04 +00:00
# Windows specific
if type "mailsend.exe" > /dev/null 2>& 1 ; then
if [ " $SMTP_ENCRYPTION " != "tls" ] && [ " $SMTP_ENCRYPTION " != "ssl" ] && [ " $SMTP_ENCRYPTION " != "none" ] ; then
Logger "Bogus smtp encryption, assuming none." "WARN"
encryption_string =
elif [ " $SMTP_ENCRYPTION " = = "tls" ] ; then
encryption_string = -starttls
elif [ " $SMTP_ENCRYPTION " = = "ssl" ] :; then
encryption_string = -ssl
fi
if [ " $SMTP_USER " != "" ] && [ " $SMTP_USER " != "" ] ; then
auth_string = " -auth -user \" $SMTP_USER \" -pass \" $SMTP_PASSWORD \" "
fi
$( type mailsend.exe) -f $SENDER_MAIL -t " $DESTINATION_MAILS " -sub " $subject " -M " $MAIL_ALERT_MSG " -attach " $attachment " -smtp " $SMTP_SERVER " -port " $SMTP_PORT " $encryption_string $auth_string
if [ $? != 0 ] ; then
Logger " Cannot send mail via $( type mailsend.exe) !!! " "WARN"
else
Logger "Sent mail using mailsend.exe command with attachment." "NOTICE"
return 0
fi
fi
# Windows specific, kept for compatibility (sendemail from http://caspian.dotconf.net/menu/Software/SendEmail/)
2015-11-12 00:37:43 +00:00
if type sendemail > /dev/null 2>& 1 ; then
if [ " $SMTP_USER " != "" ] && [ " $SMTP_PASSWORD " != "" ] ; then
SMTP_OPTIONS = " -xu $SMTP_USER -xp $SMTP_PASSWORD "
else
SMTP_OPTIONS = ""
fi
2016-05-25 17:57:04 +00:00
$( type -p sendemail) -f $SENDER_MAIL -t " $DESTINATION_MAILS " -u " $subject " -m " $MAIL_ALERT_MSG " -s $SMTP_SERVER $SMTP_OPTIONS > /dev/null 2>& 1
2015-11-12 00:37:43 +00:00
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send alert mail via $( type -p sendemail) !!! " "WARN"
2015-11-12 00:37:43 +00:00
else
Logger "Sent alert mail using sendemail command without attachment." "NOTICE"
return 0
fi
fi
2016-03-22 11:43:01 +00:00
# pfSense specific
if [ -f /usr/local/bin/mail.php ] ; then
2016-03-31 10:01:10 +00:00
echo " $MAIL_ALERT_MSG " | /usr/local/bin/mail.php -s= " $subject "
2016-03-22 11:43:01 +00:00
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger "Cannot send alert mail via /usr/local/bin/mail.php (pfsense) !!!" "WARN"
2016-03-22 11:43:01 +00:00
else
Logger "Sent alert mail using pfSense mail.php." "NOTICE"
return 0
fi
fi
2015-11-12 00:37:43 +00:00
# If function has not returned 0 yet, assume it's critical that no alert can be sent
2016-05-25 17:57:04 +00:00
Logger "Cannot send alert (neither mutt, mail, sendmail, mailsend, sendemail or pfSense mail.php could be used)." "ERROR" # Is not marked critical because execution must continue
2015-11-12 00:37:43 +00:00
# Delete tmp log file
if [ -f " $ALERT_LOG_FILE " ] ; then
rm " $ALERT_LOG_FILE "
fi
}
2016-05-25 17:57:04 +00:00
# Generic email sending function.
# Usage (linux / BSD), attachment is optional, can be "/path/to/my.file" or ""
# SendEmail "subject" "Body text" "receiver@example.com receiver2@otherdomain.com" "/path/to/attachment.file"
# Usage (Windows, make sure you have mailsend.exe in executable path, see http://github.com/muquit/mailsend)
# attachment is optional but must be in windows format like "c:\\some\path\\my.file", or ""
# smtp_server.domain.tld is mandatory, as is smtp_port (should be 25, 465 or 587)
# encryption can be set to tls, ssl or none
# smtp_user and smtp_password are optional
# SendEmail "subject" "Body text" "receiver@example.com receiver2@otherdomain.com" "/path/to/attachment.file" "sender_email@example.com" "smtp_server.domain.tld" "smtp_port" "encrpytion" "smtp_user" "smtp_password"
2016-04-14 16:01:56 +00:00
function SendEmail {
local subject = " ${ 1 } "
local message = " ${ 2 } "
local destination_mails = " ${ 3 } "
2016-05-25 17:57:04 +00:00
local attachment = " ${ 4 } "
local sender_email = " ${ 5 } "
local smtp_server = " ${ 6 } "
local smtp_port = " ${ 7 } "
local encrpytion = " ${ 8 } "
local smtp_user = " ${ 9 } "
local smtp_password = " ${ 10 } "
# CheckArguments will report a warning that can be ignored if used in Windows with paranoia debug enabled
2016-04-14 16:01:56 +00:00
__CheckArguments 4 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
local mail_no_attachment =
local attachment_command =
2016-05-25 17:57:04 +00:00
local encryption_string =
local auth_string =
2016-04-14 16:01:56 +00:00
if [ ! -f " $attachment " ] ; then
attachment_command = " -a $ALERT_LOG_FILE "
mail_no_attachment = 1
else
mail_no_attachment = 0
fi
if type mutt > /dev/null 2>& 1 ; then
echo " $message " | $( type -p mutt) -x -s " $subject " " $destination_mails " $attachment_command
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send mail via $( type -p mutt) !!! " "WARN"
2016-04-14 16:01:56 +00:00
else
2016-05-25 17:57:04 +00:00
Logger "Sent mail using mutt." "NOTICE"
2016-04-14 16:01:56 +00:00
return 0
fi
fi
if type mail > /dev/null 2>& 1 ; then
if [ " $mail_no_attachment " -eq 0 ] && $( type -p mail) -V | grep "GNU" > /dev/null; then
attachment_command = " -A $attachment "
elif [ " $mail_no_attachment " -eq 0 ] && $( type -p mail) -V > /dev/null; then
attachment_command = " -a $attachment "
else
attachment_command = ""
fi
echo " $message " | $( type -p mail) $attachment_command -s " $subject " " $destination_mails "
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send mail via $( type -p mail) with attachments !!! " "WARN"
2016-04-14 16:01:56 +00:00
echo " $message " | $( type -p mail) -s " $subject " " $destination_mails "
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send mail via $( type -p mail) without attachments !!! " "WARN"
2016-04-14 16:01:56 +00:00
else
2016-05-25 17:57:04 +00:00
Logger "Sent mail using mail command without attachment." "NOTICE"
2016-04-14 16:01:56 +00:00
return 0
fi
else
2016-05-25 17:57:04 +00:00
Logger "Sent mail using mail command." "NOTICE"
2016-04-14 16:01:56 +00:00
return 0
fi
fi
if type sendmail > /dev/null 2>& 1 ; then
echo -e " Subject: $subject \r\n $message " | $( type -p sendmail) " $destination_mails "
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send mail via $( type -p sendmail) !!! " "WARN"
2016-04-14 16:01:56 +00:00
else
2016-05-25 17:57:04 +00:00
Logger "Sent mail using sendmail command without attachment." "NOTICE"
2016-04-14 16:01:56 +00:00
return 0
fi
fi
2016-05-25 17:57:04 +00:00
# Windows specific
if type "mailsend.exe" > /dev/null 2>& 1 ; then
if [ " $sender_email " = = "" ] ; then
Logger "Missing sender email." "ERROR"
return 1
fi
if [ " $smtp_server " = = "" ] ; then
Logger "Missing smtp port." "ERROR"
return 1
fi
if [ " $smtp_port " = = "" ] ; then
Logger "Missing smtp port, assuming 25." "WARN"
smtp_port = 25
fi
if [ " $encryption " != "tls" ] && [ " $encryption " != "ssl" ] && [ " $encryption " != "none" ] ; then
Logger "Bogus smtp encryption, assuming none." "WARN"
encryption_string =
elif [ " $encryption " = = "tls" ] ; then
encryption_string = -starttls
elif [ " $encryption " = = "ssl" ] :; then
encryption_string = -ssl
fi
if [ " $smtp_user " != "" ] && [ " $smtp_password " != "" ] ; then
auth_string = " -auth -user \" $smtp_user \" -pass \" $smtp_password \" "
fi
$( type mailsend.exe) -f " $sender_email " -t " $destination_mails " -sub " $subject " -M " $message " -attach " $attachment " -smtp " $smtp_server " -port " $smtp_port " $encryption_string $auth_string
if [ $? != 0 ] ; then
Logger " Cannot send mail via $( type mailsend.exe) !!! " "WARN"
else
Logger "Sent mail using mailsend.exe command with attachment." "NOTICE"
return 0
fi
fi
2016-04-14 16:01:56 +00:00
# pfSense specific
if [ -f /usr/local/bin/mail.php ] ; then
echo " $message " | /usr/local/bin/mail.php -s= " $subject "
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger "Cannot send mail via /usr/local/bin/mail.php (pfsense) !!!" "WARN"
2016-04-14 16:01:56 +00:00
else
2016-05-25 17:57:04 +00:00
Logger "Sent mail using pfSense mail.php." "NOTICE"
2016-04-14 16:01:56 +00:00
return 0
fi
fi
# If function has not returned 0 yet, assume it's critical that no alert can be sent
2016-05-25 17:57:04 +00:00
Logger "Cannot send mail (neither mutt, mail, sendmail, sendemail, mailsend (windows) or pfSense mail.php could be used)." "ERROR" # Is not marked critical because execution must continue
2016-04-14 16:01:56 +00:00
}
2016-03-08 22:54:25 +00:00
function TrapError {
local job = " $0 "
local line = " $1 "
local code = " ${ 2 :- 1 } "
if [ $_SILENT -eq 0 ] ; then
echo -e " /!\ ERROR in ${ job } : Near line ${ line } , exit code ${ code } "
fi
}
2016-03-19 09:48:46 +00:00
function LoadConfigFile {
local config_file = " ${ 1 } "
__CheckArguments 1 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
if [ ! -f " $config_file " ] ; then
Logger " Cannot load configuration file [ $config_file ]. Cannot start. " "CRITICAL"
exit 1
elif [ [ " $1 " != *".conf" ] ] ; then
Logger " Wrong configuration file supplied [ $config_file ]. Cannot start. " "CRITICAL"
exit 1
else
grep '^[^ ]*=[^;&]*' " $config_file " > " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID " # WITHOUT COMMENTS
# Shellcheck source=./sync.conf
source " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID "
fi
CONFIG_FILE = " $config_file "
}
#### MINIMAL-FUNCTION-SET END ####
2016-03-08 22:54:25 +00:00
function Spinner {
if [ $_SILENT -eq 1 ] ; then
return 0
fi
case $toggle
in
1)
echo -n " \ "
echo -ne "\r"
toggle = "2"
; ;
2)
echo -n " | "
echo -ne "\r"
toggle = "3"
; ;
3)
echo -n " / "
echo -ne "\r"
toggle = "4"
; ;
*)
echo -n " - "
echo -ne "\r"
toggle = "1"
; ;
esac
}
2016-04-14 16:01:56 +00:00
# obsolete, use StripQuotes
2016-03-08 22:54:25 +00:00
function SedStripQuotes {
echo $( echo $1 | sed "s/^\([\"']\)\(.*\)\1\$/\2/g" )
}
2016-04-14 16:01:56 +00:00
# Usage: var=$(StripSingleQuotes "$var")
2016-03-08 22:54:25 +00:00
function StripSingleQuotes {
local string = " ${ 1 } "
string = " ${ string /# \' / } " # Remove singlequote if it begins string
string = " ${ string /% \' / } " # Remove singlequote if it ends string
echo " $string "
}
2016-04-14 16:01:56 +00:00
# Usage: var=$(StripDoubleQuotes "$var")
2016-03-08 22:54:25 +00:00
function StripDoubleQuotes {
local string = " ${ 1 } "
string = " ${ string /# \" / } "
string = " ${ string /% \" / } "
echo " $string "
}
function StripQuotes {
local string = " ${ 1 } "
echo " $( StripSingleQuotes $( StripDoubleQuotes $string ) ) "
}
function EscapeSpaces {
local string = " ${ 1 } " # String on which spaces will be escaped
echo " ${ string // / \ } "
}
function IsNumeric {
eval " local value=\" ${ 1 } \" " # Needed so variable variables can be processed
local re = " ^-?[0-9]+([.][0-9]+)? $"
if [ [ $value = ~ $re ] ] ; then
echo 1
else
echo 0
fi
}
function CleanUp {
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
if [ " $_DEBUG " != "yes" ] ; then
rm -f " $RUN_DIR / $PROGRAM . " *" . $SCRIPT_PID "
fi
}
2015-11-12 00:37:43 +00:00
function GetLocalOS {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
2016-02-18 19:54:07 +00:00
local local_os_var =
2016-02-18 22:28:57 +00:00
local_os_var = " $( uname -spio 2>& 1) "
2015-11-12 00:37:43 +00:00
if [ $? != 0 ] ; then
2016-02-18 22:28:57 +00:00
local_os_var = " $( uname -v 2>& 1) "
2015-11-12 00:37:43 +00:00
if [ $? != 0 ] ; then
2016-02-18 22:28:57 +00:00
local_os_var = " $( uname) "
2015-11-12 00:37:43 +00:00
fi
fi
case $local_os_var in
*"Linux" *)
LOCAL_OS = "Linux"
; ;
*"BSD" *)
LOCAL_OS = "BSD"
; ;
2016-03-20 15:47:51 +00:00
*"MINGW32" *| *"CYGWIN" *)
2015-11-12 00:37:43 +00:00
LOCAL_OS = "msys"
; ;
*"Darwin" *)
LOCAL_OS = "MacOSX"
; ;
*)
2016-03-19 09:48:46 +00:00
if [ " $IGNORE_OS_TYPE " = = "yes" ] ; then #DOC: Undocumented option
2016-03-20 15:53:18 +00:00
Logger " Running on unknown local OS [ $local_os_var ]. " "WARN"
2016-03-19 09:48:46 +00:00
return
fi
2015-11-12 00:37:43 +00:00
Logger " Running on >> $local_os_var << not supported. Please report to the author. " "ERROR"
exit 1
; ;
esac
Logger " Local OS: [ $local_os_var ]. " "DEBUG"
}
function GetRemoteOS {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
local cmd =
local remote_os_var =
2015-11-12 00:37:43 +00:00
if [ " $REMOTE_OPERATION " = = "yes" ] ; then
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2016-02-18 19:54:07 +00:00
cmd = $SSH_CMD ' "uname -spio" > "' $RUN_DIR /$PROGRAM .${ FUNCNAME [0] } .$SCRIPT_PID '" 2>&1'
2015-11-12 00:37:43 +00:00
Logger " cmd: $cmd " "DEBUG"
eval " $cmd " &
2016-02-18 19:54:07 +00:00
WaitForTaskCompletion $! 120 240 ${ FUNCNAME [0] } "-1"
2015-11-12 00:37:43 +00:00
retval = $?
if [ $retval != 0 ] ; then
2016-02-18 19:54:07 +00:00
cmd = $SSH_CMD ' "uname -v" > "' $RUN_DIR /$PROGRAM .${ FUNCNAME [0] } .$SCRIPT_PID '" 2>&1'
2015-11-12 00:37:43 +00:00
Logger " cmd: $cmd " "DEBUG"
eval " $cmd " &
2016-02-18 19:54:07 +00:00
WaitForTaskCompletion $! 120 240 ${ FUNCNAME [0] } "-2"
2015-11-12 00:37:43 +00:00
retval = $?
if [ $retval != 0 ] ; then
2016-02-18 19:54:07 +00:00
cmd = $SSH_CMD ' "uname" > "' $RUN_DIR /$PROGRAM .${ FUNCNAME [0] } .$SCRIPT_PID '" 2>&1'
2015-11-12 00:37:43 +00:00
Logger " cmd: $cmd " "DEBUG"
eval " $cmd " &
2016-02-18 19:54:07 +00:00
WaitForTaskCompletion $! 120 240 ${ FUNCNAME [0] } "-3"
2015-11-12 00:37:43 +00:00
retval = $?
if [ $retval != 0 ] ; then
Logger "Cannot Get remote OS type." "ERROR"
fi
fi
fi
2016-02-18 22:28:57 +00:00
remote_os_var = $( cat " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID " )
2015-11-12 00:37:43 +00:00
case $remote_os_var in
*"Linux" *)
REMOTE_OS = "Linux"
; ;
*"BSD" *)
REMOTE_OS = "BSD"
; ;
2016-03-20 15:47:51 +00:00
*"MINGW32" *| *"CYGWIN" *)
2015-11-12 00:37:43 +00:00
REMOTE_OS = "msys"
; ;
*"Darwin" *)
REMOTE_OS = "MacOSX"
; ;
*"ssh" *| *"SSH" *)
Logger "Cannot connect to remote system." "CRITICAL"
exit 1
; ;
*)
2016-03-31 08:17:50 +00:00
if [ " $IGNORE_OS_TYPE " = = "yes" ] ; then #DOC: Undocumented option
2016-03-20 15:53:18 +00:00
Logger " Running on unknown remote OS [ $remote_os_var ]. " "WARN"
2016-03-19 09:48:46 +00:00
return
fi
2015-11-12 00:37:43 +00:00
Logger "Running on remote OS failed. Please report to the author if the OS is not supported." "CRITICAL"
Logger " Remote OS said:\n $remote_os_var " "CRITICAL"
exit 1
esac
Logger " Remote OS: [ $remote_os_var ]. " "DEBUG"
fi
}
function WaitForTaskCompletion {
local pid = " ${ 1 } " # pid to wait for
local soft_max_time = " ${ 2 } " # If program with pid $pid takes longer than $soft_max_time seconds, will log a warning, unless $soft_max_time equals 0.
local hard_max_time = " ${ 3 } " # If program with pid $pid takes longer than $hard_max_time seconds, will stop execution, unless $hard_max_time equals 0.
local caller_name = " ${ 4 } " # Who called this function
2016-02-18 19:54:07 +00:00
Logger " ${ FUNCNAME [0] } called by [ $caller_name ]. " "PARANOIA_DEBUG" #__WITH_PARANOIA_DEBUG
__CheckArguments 4 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
local soft_alert = 0 # Does a soft alert need to be triggered, if yes, send an alert once
local log_ttime = 0 # local time instance for comparaison
local seconds_begin = $SECONDS # Seconds since the beginning of the script
local exec_time = 0 # Seconds since the beginning of this function
while eval " $PROCESS_TEST_CMD " > /dev/null
do
Spinner
exec_time = $(( $SECONDS - $seconds_begin ))
if [ $(( ( $exec_time + 1 ) % $KEEP_LOGGING )) -eq 0 ] ; then
if [ $log_ttime -ne $exec_time ] ; then
log_ttime = $exec_time
2016-03-31 20:32:03 +00:00
Logger " Current task still running with pid [ $pid ]. " "NOTICE"
2015-11-12 00:37:43 +00:00
fi
fi
if [ $exec_time -gt $soft_max_time ] ; then
if [ $soft_alert -eq 0 ] && [ $soft_max_time -ne 0 ] ; then
2016-03-31 20:32:03 +00:00
Logger " Max soft execution time exceeded for task [ $caller_name ] with pid [ $pid ]. " "WARN"
2015-11-12 00:37:43 +00:00
soft_alert = 1
SendAlert
fi
if [ $exec_time -gt $hard_max_time ] && [ $hard_max_time -ne 0 ] ; then
2016-03-31 20:32:03 +00:00
Logger " Max hard execution time exceeded for task [ $caller_name ] with pid [ $pid ]. Stopping task execution. " "ERROR"
KillChilds $pid
2015-11-12 00:37:43 +00:00
if [ $? = = 0 ] ; then
2016-03-31 20:32:03 +00:00
Logger "Task stopped successfully" "NOTICE"
return 0
2015-11-12 00:37:43 +00:00
else
2016-03-31 20:32:03 +00:00
return 1
2015-11-12 00:37:43 +00:00
fi
fi
fi
sleep $SLEEP_TIME
done
wait $pid
local retval = $?
2016-02-18 19:54:07 +00:00
Logger " ${ FUNCNAME [0] } ended for [ $caller_name ] with status $retval . " "PARANOIA_DEBUG" #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
return $retval
}
function WaitForCompletion {
local pid = " ${ 1 } " # pid to wait for
local soft_max_time = " ${ 2 } " # If program with pid $pid takes longer than $soft_max_time seconds, will log a warning, unless $soft_max_time equals 0.
local hard_max_time = " ${ 3 } " # If program with pid $pid takes longer than $hard_max_time seconds, will stop execution, unless $hard_max_time equals 0.
local caller_name = " ${ 4 } " # Who called this function
2016-02-18 19:54:07 +00:00
Logger " ${ FUNCNAME [0] } called by [ $caller_name ] " "PARANOIA_DEBUG" #__WITH_PARANOIA_DEBUG
__CheckArguments 4 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
local soft_alert = 0 # Does a soft alert need to be triggered, if yes, send an alert once
local log_ttime = 0 # local time instance for comparaison
local seconds_begin = $SECONDS # Seconds since the beginning of the script
local exec_time = 0 # Seconds since the beginning of this function
while eval " $PROCESS_TEST_CMD " > /dev/null
do
Spinner
if [ $(( ( $SECONDS + 1 ) % $KEEP_LOGGING )) -eq 0 ] ; then
if [ $log_time -ne $SECONDS ] ; then
log_time = $SECONDS
Logger "Current task still running." "NOTICE"
fi
fi
if [ $SECONDS -gt $soft_max_time ] ; then
if [ $soft_alert -eq 0 ] && [ $soft_max_time != 0 ] ; then
Logger "Max soft execution time exceeded for script." "WARN"
soft_alert = 1
SendAlert
fi
if [ $SECONDS -gt $hard_max_time ] && [ $hard_max_time != 0 ] ; then
2016-03-10 09:27:03 +00:00
Logger " Max hard execution time exceeded for script in [ $caller_name ]. Stopping current task execution. " "ERROR"
2016-03-31 20:32:03 +00:00
KillChilds $pid
2015-11-12 00:37:43 +00:00
if [ $? = = 0 ] ; then
2016-03-31 20:32:03 +00:00
Logger "Task stopped successfully" "NOTICE"
return 0
2015-11-12 00:37:43 +00:00
else
2016-03-31 20:32:03 +00:00
return 1
2015-11-12 00:37:43 +00:00
fi
fi
fi
sleep $SLEEP_TIME
done
wait $pid
retval = $?
2016-02-18 19:54:07 +00:00
Logger " ${ FUNCNAME [0] } ended for [ $caller_name ] with status $retval . " "PARANOIA_DEBUG" #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
return $retval
}
function RunLocalCommand {
local command = " ${ 1 } " # Command to run
local hard_max_time = " ${ 2 } " # Max time to wait for command to compleet
2016-02-18 19:54:07 +00:00
__CheckArguments 2 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
if [ $_DRYRUN -ne 0 ] ; then
Logger " Dryrun: Local command [ $command ] not run. " "NOTICE"
2015-11-19 21:39:31 +00:00
return 0
2015-11-12 00:37:43 +00:00
fi
2015-11-19 21:39:31 +00:00
2015-11-12 00:37:43 +00:00
Logger " Running command [ $command ] on local host. " "NOTICE"
2016-02-18 19:54:07 +00:00
eval " $command " > " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID " 2>& 1 &
WaitForTaskCompletion $! 0 $hard_max_time ${ FUNCNAME [0] }
2015-11-12 00:37:43 +00:00
retval = $?
if [ $retval -eq 0 ] ; then
Logger "Command succeded." "NOTICE"
else
Logger "Command failed." "ERROR"
fi
if [ $_VERBOSE -eq 1 ] || [ $retval -ne 0 ] ; then
2016-02-18 19:54:07 +00:00
Logger " Command output:\n $( cat $RUN_DIR /$PROGRAM .${ FUNCNAME [0] } .$SCRIPT_PID ) " "NOTICE"
2015-11-12 00:37:43 +00:00
fi
if [ " $STOP_ON_CMD_ERROR " = = "yes" ] && [ $retval -ne 0 ] ; then
Logger "Stopping on command execution error." "CRITICAL"
exit 1
fi
}
## Runs remote command $1 and waits for completition in $2 seconds
function RunRemoteCommand {
local command = " ${ 1 } " # Command to run
local hard_max_time = " ${ 2 } " # Max time to wait for command to compleet
2016-02-18 19:54:07 +00:00
__CheckArguments 2 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
if [ $_DRYRUN -ne 0 ] ; then
Logger " Dryrun: Local command [ $command ] not run. " "NOTICE"
2015-11-19 21:39:31 +00:00
return 0
2015-11-12 00:37:43 +00:00
fi
2015-11-19 21:39:31 +00:00
2015-11-12 00:37:43 +00:00
Logger " Running command [ $command ] on remote host. " "NOTICE"
2016-02-18 19:54:07 +00:00
cmd = $SSH_CMD ' "$command" > "' $RUN_DIR /$PROGRAM .${ FUNCNAME [0] } .$SCRIPT_PID '" 2>&1'
2015-11-12 00:37:43 +00:00
Logger " cmd: $cmd " "DEBUG"
eval " $cmd " &
2016-02-18 19:54:07 +00:00
WaitForTaskCompletion $! 0 $hard_max_time ${ FUNCNAME [0] }
2015-11-12 00:37:43 +00:00
retval = $?
if [ $retval -eq 0 ] ; then
Logger "Command succeded." "NOTICE"
else
Logger "Command failed." "ERROR"
fi
2016-02-18 19:54:07 +00:00
if [ -f " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID " ] && ( [ $_VERBOSE -eq 1 ] || [ $retval -ne 0 ] )
2015-11-12 00:37:43 +00:00
then
2016-02-18 19:54:07 +00:00
Logger " Command output:\n $( cat $RUN_DIR /$PROGRAM .${ FUNCNAME [0] } .$SCRIPT_PID ) " "NOTICE"
2015-11-12 00:37:43 +00:00
fi
if [ " $STOP_ON_CMD_ERROR " = = "yes" ] && [ $retval -ne 0 ] ; then
Logger "Stopping on command execution error." "CRITICAL"
exit 1
fi
}
function RunBeforeHook {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
if [ " $LOCAL_RUN_BEFORE_CMD " != "" ] ; then
RunLocalCommand " $LOCAL_RUN_BEFORE_CMD " $MAX_EXEC_TIME_PER_CMD_BEFORE
fi
if [ " $REMOTE_RUN_BEFORE_CMD " != "" ] ; then
RunRemoteCommand " $REMOTE_RUN_BEFORE_CMD " $MAX_EXEC_TIME_PER_CMD_BEFORE
fi
}
function RunAfterHook {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
if [ " $LOCAL_RUN_AFTER_CMD " != "" ] ; then
RunLocalCommand " $LOCAL_RUN_AFTER_CMD " $MAX_EXEC_TIME_PER_CMD_AFTER
fi
if [ " $REMOTE_RUN_AFTER_CMD " != "" ] ; then
RunRemoteCommand " $REMOTE_RUN_AFTER_CMD " $MAX_EXEC_TIME_PER_CMD_AFTER
fi
}
function CheckConnectivityRemoteHost {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
if [ " $_PARANOIA_DEBUG " != "yes" ] ; then # Do not loose time in paranoia debug
if [ " $REMOTE_HOST_PING " != "no" ] && [ " $REMOTE_OPERATION " != "no" ] ; then
eval " $PING_CMD $REMOTE_HOST > /dev/null 2>&1 " &
2016-02-18 19:54:07 +00:00
WaitForTaskCompletion $! 180 180 ${ FUNCNAME [0] }
2015-11-12 00:37:43 +00:00
if [ $? != 0 ] ; then
2016-04-08 19:10:54 +00:00
Logger " Cannot ping $REMOTE_HOST " "ERROR"
2015-11-12 00:37:43 +00:00
return 1
fi
fi
fi
}
function CheckConnectivity3rdPartyHosts {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
if [ " $_PARANOIA_DEBUG " != "yes" ] ; then # Do not loose time in paranoia debug
if [ " $REMOTE_3RD_PARTY_HOSTS " != "" ] ; then
remote_3rd_party_success = 0
OLD_IFS = $IFS
IFS = $' \t\n'
for i in $REMOTE_3RD_PARTY_HOSTS
do
eval " $PING_CMD $i > /dev/null 2>&1 " &
2016-02-18 19:54:07 +00:00
WaitForTaskCompletion $! 360 360 ${ FUNCNAME [0] }
2015-11-12 00:37:43 +00:00
if [ $? != 0 ] ; then
2016-03-10 09:27:03 +00:00
Logger " Cannot ping 3rd party host $i " "NOTICE"
2015-11-12 00:37:43 +00:00
else
remote_3rd_party_success = 1
fi
done
IFS = $OLD_IFS
if [ $remote_3rd_party_success -ne 1 ] ; then
2016-03-10 09:27:03 +00:00
Logger "No remote 3rd party host responded to ping. No internet ?" "ERROR"
2015-11-12 00:37:43 +00:00
return 1
fi
fi
fi
}
#__BEGIN_WITH_PARANOIA_DEBUG
function __CheckArguments {
# Checks the number of arguments of a function and raises an error if some are missing
if [ " $_DEBUG " = = "yes" ] ; then
local number_of_arguments = " ${ 1 } " # Number of arguments the tested function should have
local number_of_given_arguments = " ${ 2 } " # Number of arguments that have been passed
local function_name = " ${ 3 } " # Function name that called __CheckArguments
if [ " $_PARANOIA_DEBUG " = = "yes" ] ; then
Logger " Entering function [ $function_name ]. " "DEBUG"
fi
# All arguments of the function to check are passed as array in ${4} (the function call waits for $@)
# If any of the arguments contains spaces, bash things there are two aguments
# In order to avoid this, we need to iterate over ${4} and count
local iterate = 4
local fetch_arguments = 1
local arg_list = ""
while [ $fetch_arguments -eq 1 ] ; do
cmd = 'argument=${' $iterate '}'
eval $cmd
if [ " $argument " = "" ] ; then
fetch_arguments = 0
else
arg_list = " $arg_list [Argument $(( $iterate - 3 )) : $argument ] "
iterate = $(( $iterate + 1 ))
fi
done
local counted_arguments = $(( iterate-4))
if [ $counted_arguments -ne $number_of_arguments ] ; then
2016-04-01 19:29:33 +00:00
Logger " Function $function_name may have inconsistent number of arguments. Expected: $number_of_arguments , count: $counted_arguments , bash seen: $number_of_given_arguments . see log file. " "ERROR"
2015-11-12 00:37:43 +00:00
Logger " Arguments passed: $arg_list " "ERROR"
fi
fi
}
2016-02-21 10:12:41 +00:00
#__END_WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
2016-02-21 10:12:41 +00:00
function RsyncPatternsAdd {
2016-04-01 19:29:33 +00:00
local pattern_type = " ${ 1 } " # exclude or include
local pattern = " ${ 2 } "
2016-02-21 10:12:41 +00:00
__CheckArguments 2 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
2016-02-21 10:12:41 +00:00
local rest =
2015-11-12 00:37:43 +00:00
2016-02-21 10:12:41 +00:00
# Disable globbing so wildcards from exclusions do not get expanded
set -f
rest = " $pattern "
while [ -n " $rest " ]
do
# Take the string until first occurence until $PATH_SEPARATOR_CHAR
str = ${ rest %%;* }
# Handle the last case
if [ " $rest " = " ${ rest / $PATH_SEPARATOR_CHAR / } " ] ; then
rest =
else
# Cut everything before the first occurence of $PATH_SEPARATOR_CHAR
rest = ${ rest #* $PATH_SEPARATOR_CHAR }
2015-11-12 00:37:43 +00:00
fi
2016-02-21 10:12:41 +00:00
if [ " $RSYNC_PATTERNS " = = "" ] ; then
RSYNC_PATTERNS = "--" $pattern_type " =\" $str \" "
else
RSYNC_PATTERNS = " $RSYNC_PATTERNS -- " $pattern_type " =\" $str \" "
2015-11-12 00:37:43 +00:00
fi
2016-02-21 10:12:41 +00:00
done
set +f
}
2015-11-12 00:37:43 +00:00
2016-02-21 10:12:41 +00:00
function RsyncPatternsFromAdd {
2016-04-01 19:29:33 +00:00
local pattern_type = " ${ 1 } "
local pattern_from = " ${ 2 } "
2016-02-21 10:12:41 +00:00
__CheckArguments 2 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
local pattern_from =
## Check if the exclude list has a full path, and if not, add the config file path if there is one
if [ " $( basename $pattern_from ) " = = " $pattern_from " ] ; then
pattern_from = " $( dirname $CONFIG_FILE ) / $pattern_from "
fi
if [ -e " $pattern_from " ] ; then
RSYNC_PATTERNS = " $RSYNC_PATTERNS -- " $pattern_type " -from=\" $pattern_from \" "
fi
}
function RsyncPatterns {
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
if [ " $RSYNC_PATTERN_FIRST " = = "exclude" ] ; then
2016-04-01 19:29:33 +00:00
RsyncPatternsAdd "exclude" " $RSYNC_EXCLUDE_PATTERN "
2016-02-21 10:12:41 +00:00
if [ " $RSYNC_EXCLUDE_FROM " != "" ] ; then
2016-04-01 19:29:33 +00:00
RsyncPatternsFromAdd "exclude" " $RSYNC_EXCLUDE_FROM "
2016-02-21 10:12:41 +00:00
fi
RsyncPatternsAdd " $RSYNC_INCLUDE_PATTERN " "include"
if [ " $RSYNC_INCLUDE_FROM " != "" ] ; then
2016-04-01 19:29:33 +00:00
RsyncPatternsFromAdd "include" " $RSYNC_INCLUDE_FROM "
2016-02-21 10:12:41 +00:00
fi
elif [ " $RSYNC_PATTERN_FIRST " = = "include" ] ; then
2016-04-01 19:29:33 +00:00
RsyncPatternsAdd "include" " $RSYNC_INCLUDE_PATTERN "
2016-02-21 10:12:41 +00:00
if [ " $RSYNC_INCLUDE_FROM " != "" ] ; then
2016-04-01 19:29:33 +00:00
RsyncPatternsFromAdd "include" " $RSYNC_INCLUDE_FROM "
2016-02-21 10:12:41 +00:00
fi
2016-04-01 19:29:33 +00:00
RsyncPatternsAdd "exclude" " $RSYNC_EXCLUDE_PATTERN "
2016-02-21 10:12:41 +00:00
if [ " $RSYNC_EXCLUDE_FROM " != "" ] ; then
2016-04-01 19:29:33 +00:00
RsyncPatternsFromAdd "exclude" " $RSYNC_EXCLUDE_FROM "
2016-02-21 10:12:41 +00:00
fi
else
Logger "Bogus RSYNC_PATTERN_FIRST value in config file. Will not use rsync patterns." "WARN"
fi
2015-11-12 00:37:43 +00:00
}
function PreInit {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
## SSH compression
if [ " $SSH_COMPRESSION " != "no" ] ; then
SSH_COMP = -C
else
SSH_COMP =
fi
2016-03-29 20:55:57 +00:00
## Ignore SSH known host verification
if [ " $SSH_IGNORE_KNOWN_HOSTS " = = "yes" ] ; then
SSH_OPTS = "-o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no"
fi
2015-11-12 00:37:43 +00:00
## Support for older config files without RSYNC_EXECUTABLE option
if [ " $RSYNC_EXECUTABLE " = = "" ] ; then
RSYNC_EXECUTABLE = rsync
fi
## Sudo execution option
if [ " $SUDO_EXEC " = = "yes" ] ; then
if [ " $RSYNC_REMOTE_PATH " != "" ] ; then
RSYNC_PATH = " sudo $RSYNC_REMOTE_PATH / $RSYNC_EXECUTABLE "
else
RSYNC_PATH = " sudo $RSYNC_EXECUTABLE "
fi
COMMAND_SUDO = "sudo"
else
if [ " $RSYNC_REMOTE_PATH " != "" ] ; then
RSYNC_PATH = " $RSYNC_REMOTE_PATH / $RSYNC_EXECUTABLE "
else
RSYNC_PATH = " $RSYNC_EXECUTABLE "
fi
COMMAND_SUDO = ""
fi
## Set rsync default arguments
2016-02-16 19:52:53 +00:00
RSYNC_ARGS = "-rltD"
RSYNC_ATTR_ARGS = "-pgo"
2016-02-19 20:44:52 +00:00
if [ " $_DRYRUN " -eq 1 ] ; then
RSYNC_DRY_ARG = "-n"
DRY_WARNING = "/!\ DRY RUN"
else
RSYNC_DRY_ARG = ""
fi
2015-11-12 00:37:43 +00:00
if [ " $PRESERVE_ACL " = = "yes" ] ; then
2016-02-16 19:52:53 +00:00
RSYNC_ATTR_ARGS = $RSYNC_ATTR_ARGS " -A"
2015-11-12 00:37:43 +00:00
fi
if [ " $PRESERVE_XATTR " = = "yes" ] ; then
2016-02-16 19:52:53 +00:00
RSYNC_ATTR_ARGS = $RSYNC_ATTR_ARGS " -X"
2015-11-12 00:37:43 +00:00
fi
if [ " $RSYNC_COMPRESS " = = "yes" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " -z"
fi
if [ " $COPY_SYMLINKS " = = "yes" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " -L"
fi
if [ " $KEEP_DIRLINKS " = = "yes" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " -K"
fi
if [ " $PRESERVE_HARDLINKS " = = "yes" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " -H"
fi
if [ " $CHECKSUM " = = "yes" ] ; then
2016-02-16 19:52:53 +00:00
RSYNC_TYPE_ARGS = $RSYNC_TYPE_ARGS " --checksum"
2015-11-12 00:37:43 +00:00
fi
if [ " $BANDWIDTH " != "" ] && [ " $BANDWIDTH " != "0" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " --bwlimit= $BANDWIDTH "
fi
2016-02-16 19:52:53 +00:00
if [ " $PARTIAL " = = "yes" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " --partial --partial-dir=\" $PARTIAL_DIR \" "
RSYNC_PARTIAL_EXCLUDE = " --exclude=\" $PARTIAL_DIR \" "
fi
if [ " $DELTA_COPIES " != "no" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " --no-whole-file"
else
RSYNC_ARGS = $RSYNC_ARGS " --whole-file"
fi
2015-11-12 00:37:43 +00:00
## Set compression executable and extension
COMPRESSION_LEVEL = 3
if type xz > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | xz - $COMPRESSION_LEVEL "
COMPRESSION_EXTENSION = .xz
elif type lzma > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | lzma - $COMPRESSION_LEVEL "
COMPRESSION_EXTENSION = .lzma
elif type pigz > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | pigz - $COMPRESSION_LEVEL "
2016-02-18 22:28:57 +00:00
COMPRESSION_EXTENSION = .gz
# obackup specific
2015-11-12 00:37:43 +00:00
COMPRESSION_OPTIONS = --rsyncable
elif type gzip > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | gzip - $COMPRESSION_LEVEL "
COMPRESSION_EXTENSION = .gz
2016-02-18 22:28:57 +00:00
# obackup specific
2015-11-12 00:37:43 +00:00
COMPRESSION_OPTIONS = --rsyncable
else
COMPRESSION_PROGRAM =
COMPRESSION_EXTENSION =
fi
ALERT_LOG_FILE = " $ALERT_LOG_FILE $COMPRESSION_EXTENSION "
}
function PostInit {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
# Define remote commands
2016-03-31 08:17:50 +00:00
SSH_CMD = " $( type -p ssh) $SSH_COMP -i $SSH_RSA_PRIVATE_KEY $SSH_OPTS $REMOTE_USER @ $REMOTE_HOST -p $REMOTE_PORT "
2015-11-12 00:37:43 +00:00
SCP_CMD = " $( type -p scp) $SSH_COMP -i $SSH_RSA_PRIVATE_KEY -P $REMOTE_PORT "
2016-03-31 08:17:50 +00:00
RSYNC_SSH_CMD = " $( type -p ssh) $SSH_COMP -i $SSH_RSA_PRIVATE_KEY $SSH_OPTS -p $REMOTE_PORT "
2015-11-12 00:37:43 +00:00
}
function InitLocalOSSettings {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
## If running under Msys, some commands do not run the same way
## Using mingw version of find instead of windows one
## Getting running processes is quite different
## Ping command is not the same
if [ " $LOCAL_OS " = = "msys" ] ; then
FIND_CMD = $( dirname $BASH ) /find
# PROCESS_TEST_CMD assumes there is a variable $pid
2016-04-08 19:10:54 +00:00
# Tested on MSYS and cygwin
2015-11-12 00:37:43 +00:00
PROCESS_TEST_CMD = 'ps -a | awk "{\$1=\$1}\$1" | awk "{print \$1}" | grep $pid'
2016-04-08 19:10:54 +00:00
PING_CMD = '$SYSTEMROOT\system32\ping -n 2'
2015-11-12 00:37:43 +00:00
else
FIND_CMD = find
# PROCESS_TEST_CMD assumes there is a variable $pid
PROCESS_TEST_CMD = 'ps -p$pid'
PING_CMD = "ping -c 2 -i .2"
fi
## Stat command has different syntax on Linux and FreeBSD/MacOSX
if [ " $LOCAL_OS " = = "MacOSX" ] || [ " $LOCAL_OS " = = "BSD" ] ; then
STAT_CMD = "stat -f \"%Sm\""
2016-04-03 14:06:45 +00:00
STAT_CTIME_MTIME_CMD = "stat -f %N;%c;%m"
2015-11-12 00:37:43 +00:00
else
STAT_CMD = "stat --format %y"
2016-04-03 14:06:45 +00:00
STAT_CTIME_MTIME_CMD = "stat -c %n;%Z;%Y"
2015-11-12 00:37:43 +00:00
fi
}
function InitRemoteOSSettings {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
## MacOSX does not use the -E parameter like Linux or BSD does (-E is mapped to extended attrs instead of preserve executability)
if [ " $LOCAL_OS " != "MacOSX" ] && [ " $REMOTE_OS " != "MacOSX" ] ; then
2016-02-16 19:52:53 +00:00
RSYNC_ATTR_ARGS = $RSYNC_ATTR_ARGS " -E"
2015-11-12 00:37:43 +00:00
fi
if [ " $REMOTE_OS " = = "msys" ] ; then
REMOTE_FIND_CMD = $( dirname $BASH ) /find
else
REMOTE_FIND_CMD = find
fi
2016-04-03 14:06:45 +00:00
## Stat command has different syntax on Linux and FreeBSD/MacOSX
if [ " $LOCAL_OS " = = "MacOSX" ] || [ " $LOCAL_OS " = = "BSD" ] ; then
REMOTE_STAT_CMD = "stat -f \"%Sm\""
REMOTE_STAT_CTIME_MTIME_CMD = "stat -f \\\"%N;%c;%m\\\""
else
REMOTE_STAT_CMD = "stat --format %y"
REMOTE_STAT_CTIME_MTIME_CMD = "stat -c \\\"%n;%Z;%Y\\\""
fi
2015-11-12 00:37:43 +00:00
}
## END Generic functions